diff --git a/src/main/java/net/minecraft/core/block/SnowLayerBlock.java b/src/main/java/net/minecraft/core/block/SnowLayerBlock.java
index e03309eb7..02fe4c8cd 100644
--- a/src/main/java/net/minecraft/core/block/SnowLayerBlock.java
+++ b/src/main/java/net/minecraft/core/block/SnowLayerBlock.java
@@ -78,7 +78,7 @@ public class SnowLayerBlock extends BaseLayerBlock
     {
         if(!canPlaceBlockAt(world, i, j, k))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
             world.setBlockWithNotify(i, j, k, 0);
             return false;
         } else
@@ -109,12 +109,12 @@ public class SnowLayerBlock extends BaseLayerBlock
     {
 		if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 11)
 		{
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
 			world.setBlockWithNotify(x, y, z, 0);
 		}
         if(world.getBlockBiome(x, y, z) != null && !world.getBlockBiome(x, y, z).hasSurfaceSnow() && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow)
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/SpikesBlock.java b/src/main/java/net/minecraft/core/block/SpikesBlock.java
index b9446e445..9e80c1cfd 100644
--- a/src/main/java/net/minecraft/core/block/SpikesBlock.java
+++ b/src/main/java/net/minecraft/core/block/SpikesBlock.java
@@ -46,7 +46,7 @@ public class SpikesBlock extends CobwebBlock
 		
 		boolean destroy = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z) && world.getBlockId(x, y - 1, z) != Blocks.MESH.id && world.getBlockId(x, y - 1, z) != Blocks.MOBSPAWNER.id;
 		if(destroy) {
-			dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+			dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
 			world.setBlockWithNotify(x, y, z, 0);
 			return;
 		}
diff --git a/src/main/java/net/minecraft/core/block/SugarcaneBlock.java b/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
index bcadba290..c9e8017ed 100644
--- a/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
+++ b/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
@@ -101,7 +101,7 @@ public class SugarcaneBlock extends Block implements IBonemealable
     {
         if(!canBlockStay(world, i, j, k))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
             world.setBlockWithNotify(i, j, k, 0);
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/TorchBlock.java b/src/main/java/net/minecraft/core/block/TorchBlock.java
index 9a6a29bcf..c0174f91a 100644
--- a/src/main/java/net/minecraft/core/block/TorchBlock.java
+++ b/src/main/java/net/minecraft/core/block/TorchBlock.java
@@ -163,7 +163,7 @@ public class TorchBlock extends Block
             }
             if(flag)
             {
-                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, i1, null);
+                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, i1, null, null);
                 world.setBlockWithNotify(x, y, z, 0);
             }
         }
@@ -173,7 +173,7 @@ public class TorchBlock extends Block
     {
         if(!canPlaceBlockAt(world, i, j, k))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
             world.setBlockWithNotify(i, j, k, 0);
             return false;
         } else
diff --git a/src/main/java/net/minecraft/core/block/TrommelBlock.java b/src/main/java/net/minecraft/core/block/TrommelBlock.java
index 12887ff9c..2df0d5901 100644
--- a/src/main/java/net/minecraft/core/block/TrommelBlock.java
+++ b/src/main/java/net/minecraft/core/block/TrommelBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.TrommelBlockEntity;
@@ -10,11 +11,13 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 import java.util.Random;
 
 public class TrommelBlock extends RotatableEntityBlock
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
 	public TrommelBlock(String key, String namespaceId, int id, Material material, boolean isActive)
     {
         super(key, namespaceId, id, material);
@@ -49,7 +52,7 @@ public class TrommelBlock extends RotatableEntityBlock
     {
         if (!world.isClientSide) {
             TrommelBlockEntity tileEntityTrommel = (TrommelBlockEntity) world.getBlockEntity(x, y, z);
-            player.displayGUITrommel(tileEntityTrommel);
+            player.displayTrommelScreen(tileEntityTrommel);
         }
         return true;
     }
@@ -68,14 +71,14 @@ public class TrommelBlock extends RotatableEntityBlock
     public static void updateTrommelBlockState(boolean flag, World world, int i, int j, int k)
     {
         int l = world.getBlockMetadata(i, j, k);
-        BlockEntity tileentity = world.getBlockEntity(i, j, k);
-        if(tileentity == null) {
+        BlockEntity blockEntity = world.getBlockEntity(i, j, k);
+        if(blockEntity == null) {
             String msg = "Trommel is missing Tile Entity at x: " + i + " y: " + j + " z: " + k + ", block will be removed!";
             if(Global.BUILD_CHANNEL.isUnstableBuild()) {
                 throw new RuntimeException(msg);
             }
             world.setBlockWithNotify(i, j, k, 0);
-            System.out.println(msg);
+            LOGGER.warn(msg);
             return;
         }
         keepTrommelInventory = true;
@@ -88,8 +91,8 @@ public class TrommelBlock extends RotatableEntityBlock
         }
         keepTrommelInventory = false;
         world.setBlockMetadataWithNotify(i, j, k, l);
-        tileentity.validate();
-        world.setBlockTileEntity(i, j, k, tileentity);
+        blockEntity.validate();
+        world.setBlockTileEntity(i, j, k, blockEntity);
     }
     
     @Override
@@ -99,11 +102,11 @@ public class TrommelBlock extends RotatableEntityBlock
     	{
     		if(world.getBlockEntity(x, y, z) != null)
     		{
-    			TrommelBlockEntity tileentitytrommel = (TrommelBlockEntity) world.getBlockEntity(x, y, z);
+    			TrommelBlockEntity trommel = (TrommelBlockEntity) world.getBlockEntity(x, y, z);
     			label0:
-				for (int l = 0; l < tileentitytrommel.getContainerSize(); l++)
+				for (int l = 0; l < trommel.getContainerSize(); l++)
 				{
-					ItemStack itemstack = tileentitytrommel.getItem(l);
+					ItemStack itemstack = trommel.getItem(l);
 					if (itemstack == null) {
 						continue;
 					}
@@ -119,12 +122,12 @@ public class TrommelBlock extends RotatableEntityBlock
 							i1 = itemstack.stackSize;
 						}
 						itemstack.stackSize -= i1;
-						ItemEntity entityitem = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+						ItemEntity item = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
 						float f3 = 0.05F;
-						entityitem.xd = (float) random.nextGaussian() * f3;
-						entityitem.yd = (float) random.nextGaussian() * f3 + 0.2F;
-						entityitem.zd = (float) random.nextGaussian() * f3;
-						world.entityJoinedWorld(entityitem);
+						item.xd = (float) random.nextGaussian() * f3;
+						item.yd = (float) random.nextGaussian() * f3 + 0.2F;
+						item.zd = (float) random.nextGaussian() * f3;
+						world.entityJoinedWorld(item);
 					} while (true);
 				}
     		}
diff --git a/src/main/java/net/minecraft/core/block/WoolBlock.java b/src/main/java/net/minecraft/core/block/WoolBlock.java
index 1cf8852de..315025490 100644
--- a/src/main/java/net/minecraft/core/block/WoolBlock.java
+++ b/src/main/java/net/minecraft/core/block/WoolBlock.java
@@ -2,15 +2,23 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+
 public class WoolBlock extends Block
 {
     public WoolBlock(String key, String namespaceId, int id) {
 
         super(key, namespaceId, id, Material.cloth);
     }
+    
+    @Override
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    	return stack.getMetadata() & 0xF;
+    }
 
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
diff --git a/src/main/java/net/minecraft/core/block/WorkbenchBlock.java b/src/main/java/net/minecraft/core/block/WorkbenchBlock.java
index 3ff1605f6..5b300247e 100644
--- a/src/main/java/net/minecraft/core/block/WorkbenchBlock.java
+++ b/src/main/java/net/minecraft/core/block/WorkbenchBlock.java
@@ -21,7 +21,7 @@ public class WorkbenchBlock extends Block
     {
         if (!world.isClientSide)
         {
-            player.displayGUIWorkbench(x, y, z);
+            player.displayWorkbenchScreen(x, y, z);
         }
         return true;
     }
diff --git a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
index 9a8b24ee1..00c13fa48 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
@@ -1,10 +1,13 @@
 package net.minecraft.core.block.entity;
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.piston.MovingPistonBlockEntity;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 import java.util.HashMap;
 import java.util.Map;
@@ -16,21 +19,21 @@ import java.util.Map;
 
 public class BlockEntity
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
 
     public BlockEntity()
     {
     }
 
-    private static void addMapping(Class class1, String s)
+    private static void addMapping(Class<? extends BlockEntity> entityClass, String name)
     {
-        if(classToNameMap.containsKey(s))
+        if(nameToClassMap.containsKey(name))
         {
-            throw new IllegalArgumentException((new StringBuilder()).append("Duplicate id: ").append(s).toString());
+            throw new IllegalArgumentException("Duplicate id: " + name);
         } else
         {
-            nameToClassMap.put(s, class1);
-            classToNameMap.put(class1, s);
-            return;
+            nameToClassMap.put(name, entityClass);
+            classToNameMap.put(entityClass, name);
         }
     }
 
@@ -43,17 +46,16 @@ public class BlockEntity
 
     public void writeToNBT(CompoundTag nbttagcompound)
     {
-        String s = (String)classToNameMap.get(getClass());
-        if(s == null)
+        String name = classToNameMap.get(getClass());
+        if(name == null)
         {
             throw new RuntimeException(getClass() + " is missing a mapping! This is a bug!");
         } else
         {
-            nbttagcompound.putString("id", s);
+            nbttagcompound.putString("id", name);
             nbttagcompound.putInt("x", x);
             nbttagcompound.putInt("y", y);
             nbttagcompound.putInt("z", z);
-            return;
         }
     }
 
@@ -63,32 +65,32 @@ public class BlockEntity
 
     public static BlockEntity createAndLoadEntity(CompoundTag nbttagcompound)
     {
-        BlockEntity tileentity = null;
+        BlockEntity blockEntity = null;
+        Class<? extends BlockEntity> entityClass = nameToClassMap.get(nbttagcompound.getString("id"));
         try
         {
-            Class class1 = (Class)nameToClassMap.get(nbttagcompound.getString("id"));
-            if(class1 != null)
+            if(entityClass != null)
             {
-                tileentity = (BlockEntity)class1.newInstance();
+                blockEntity = entityClass.newInstance();
             }
         }
         catch(Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Exception when instancing class '{}'!", entityClass.getSimpleName(), exception);
         }
-        if(tileentity != null)
+        if(blockEntity != null)
         {
-            tileentity.readFromNBT(nbttagcompound);
+            blockEntity.readFromNBT(nbttagcompound);
         } else
         {
-            System.out.println("Skipping BlockEntity with id " + nbttagcompound.getString("id"));
+            LOGGER.warn("Skipping BlockEntity with id {}", nbttagcompound.getString("id"));
         }
-        return tileentity;
+        return blockEntity;
     }
 
-    public static Class<?> getClassFromID(String id)
+    public static Class<? extends BlockEntity> getClassFromID(String id)
     {
-        return (Class<?>)nameToClassMap.get(id);
+        return nameToClassMap.get(id);
     }
 
     public int getMovedData()
@@ -137,8 +139,8 @@ public class BlockEntity
         tileEntityInvalid = false;
     }
 
-    private static Map nameToClassMap = new HashMap();
-    private static Map classToNameMap = new HashMap();
+    private static final Map<String, Class<? extends BlockEntity>> nameToClassMap = new HashMap<>();
+    private static final Map<Class<? extends BlockEntity>, String> classToNameMap = new HashMap<>();
     public World worldObj;
     public int x;
     public int y;
diff --git a/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
index aae0feea3..1b90a467a 100644
--- a/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.entity;
 
 import java.util.Random;
+import java.util.UUID;
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
@@ -11,6 +12,8 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.BlockEntityDataPacket;
 import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.util.helper.UUIDHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class FlagBlockEntity extends BlockEntity
     implements Container
@@ -20,7 +23,7 @@ public class FlagBlockEntity extends BlockEntity
     public final byte[] flagColors = new byte[CANVAS_WIDTH * CANVAS_HEIGHT];
     
     public ItemStack[] items = new ItemStack[3];
-    public String owner = "";
+    public @Nullable UUID owner;
     
     public int sway = new Random().nextInt(100); // Random start value
     
@@ -68,7 +71,7 @@ public class FlagBlockEntity extends BlockEntity
     {
         byte[] packedColors = packFlagColors(flagColors);
         tag.putByteArray("Colors", packedColors);
-        tag.putString("Owner", owner);
+        UUIDHelper.writeToTag(tag, owner, "OwnerUUID");
 
         ListTag list = new ListTag();
         for (int i = 0; i < items.length; i++)
@@ -97,7 +100,18 @@ public class FlagBlockEntity extends BlockEntity
         if (packedColors == null) packedColors = new byte[(CANVAS_WIDTH * CANVAS_HEIGHT) / 4];
         byte[] unpackedColors = unpackFlagColors(packedColors);
         System.arraycopy(unpackedColors, 0, flagColors, 0, CANVAS_WIDTH * CANVAS_HEIGHT);
-        owner = tag.getStringOrDefault("Owner", "");
+
+        UUID ownerUUID = UUIDHelper.readFromTag(tag, "OwnerUUID");
+        if (ownerUUID == null) {
+            String s = tag.getString("Owner");
+            if (!s.isEmpty()) {
+                UUIDHelper.runConversionAction(s,
+                    (uuid) -> this.owner = uuid,
+                    null);
+            }
+        } else {
+            this.owner = ownerUUID;
+        }
 
         ListTag list = tag.getList("Items");
         items = new ItemStack[getContainerSize()];
@@ -115,9 +129,11 @@ public class FlagBlockEntity extends BlockEntity
     public void copyFlagNBT(CompoundTag tag) {
 
         byte[] packedColors = packFlagColors(flagColors);
-        String copyOwner = tag.getStringOrDefault("Owner", "");
-        if(copyOwner.isEmpty())
-            tag.putString("Owner", owner);
+        UUID copyOwner = UUIDHelper.readFromTag(tag, "OwnerUUID");
+        if(copyOwner != null) {
+            UUIDHelper.writeToTag(tag, owner, "OwnerUUID");
+        }
+
         tag.putByteArray("Colors", packedColors);
     }
 
diff --git a/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
index 13826753b..8383010e4 100644
--- a/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block.entity;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.MobCategory;
@@ -9,11 +10,13 @@ import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.SetMobSpawnerPacket;
 import net.minecraft.core.entity.SpawnListEntry;
+import org.slf4j.Logger;
 
 import java.util.List;
 
 public class MobSpawnerBlockEntity extends BlockEntity
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public int delay;
     private String mobId;
     public double yaw;
@@ -166,9 +169,9 @@ public class MobSpawnerBlockEntity extends BlockEntity
     	delay = 200 + worldObj.rand.nextInt(600);
     	if(mobId == null) {
     		delay *= 2;
-    		System.out.println("x2");
+            LOGGER.debug("x2");
     		if(nearby > 1) {
-    			System.out.println("x4");
+                LOGGER.debug("x4");
     			delay *= 4;
     		}
     	}
diff --git a/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
index fa243d89e..f34335af4 100644
--- a/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
@@ -6,6 +6,10 @@ import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.util.helper.UUIDHelper;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.UUID;
 
 public class SignBlockEntity extends BlockEntity
 {
@@ -13,7 +17,7 @@ public class SignBlockEntity extends BlockEntity
     public int lineBeingEdited;
     private int selectedPicture = 0;
     private int selectedColor = 15;
-    private String owner = "";
+    private @Nullable UUID owner;
     private boolean glowing = false;
 
     public SignBlockEntity()
@@ -32,7 +36,7 @@ public class SignBlockEntity extends BlockEntity
         tag.putInt("Picture", selectedPicture);
         tag.putInt("Color", selectedColor);
         tag.putBoolean("Glowing", glowing);
-        tag.putString("Owner", owner);
+        UUIDHelper.writeToTag(tag, owner, "OwnerUUID");
     }
 
     @Override
@@ -50,16 +54,27 @@ public class SignBlockEntity extends BlockEntity
         selectedPicture = tag.getIntegerOrDefault("Picture", 0);
         selectedColor = tag.getIntegerOrDefault("Color", 15);
         glowing = tag.getBooleanOrDefault("Glowing", false);
-        owner = tag.getString("Owner");
+
+        UUID ownerUUID = UUIDHelper.readFromTag(tag, "OwnerUUID");
+        if (ownerUUID == null) {
+            String s = tag.getString("Owner");
+            if (!s.isEmpty()) {
+                UUIDHelper.runConversionAction(s,
+                    (uuid) -> this.owner = uuid,
+                    null);
+            }
+        } else {
+            this.owner = ownerUUID;
+        }
     }
     
     public boolean isEditableBy(Player player)
     {
-        return player.username.equals(owner);
+        return player.uuid.equals(owner);
     }
 
     public void setOwner(Player player){
-        this.owner = player.username;
+        this.owner = player.uuid;
     }
 
     public EnumSignPicture getPicture()
diff --git a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
index 094d8a83e..afcd2da8d 100644
--- a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.entity;
 
 
+import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
@@ -8,6 +9,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.ChestBlock;
 import net.minecraft.core.block.TrommelBlock;
 import net.minecraft.core.crafting.LookupFuelFurnace;
+import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.monster.SlimeMob;
@@ -17,6 +19,8 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 import java.util.HashMap;
 import java.util.List;
@@ -377,33 +381,68 @@ public class TrommelBlockEntity extends BlockEntity
     }
 
     private void simulateTrommelDrops(int passes, ItemStack blockToTest){
-        Map<Item, Integer> trommelDropMap = new HashMap<>();
+        Map<Object, Integer> trommelDropMap = new HashMap<>();
         System.out.println();
-        System.out.println("Generating simulation of Trommel loot for block: " + blockToTest.getItem().getKey());
+        System.out.println("Generating simulation of Trommel loot for block: " + blockToTest.getItem().namespaceID);
         for(int i = 0; i < passes; i++){
             ItemStack itemStack = this.getItemResult(blockToTest);
             if(itemStack != null){
                 Item item = itemStack.getItem();
-                trommelDropMap.put(item, trommelDropMap.getOrDefault(item, 0) + 1);
+                trommelDropMap.put(item.namespaceID, trommelDropMap.getOrDefault(item.namespaceID, 0) + 1);
+            } else {
+                trommelDropMap.put("NULL", trommelDropMap.getOrDefault("NULL", 0) + 1);
             }
         }
         System.out.println("Trommel loot sampling " + passes + " passes:");
         for (Item item : Item.itemsList)
         {
+            if (item == null) continue;;
+            Integer amount = trommelDropMap.get(item.namespaceID);
             float percentage;
-            if (trommelDropMap.containsKey(item))
+            if (amount != null)
             {
-                percentage = trommelDropMap.get(item) / (float) (passes);
+                percentage = amount / (float) (passes);
                 percentage *= 100;
             } else {
                 percentage = 0.0f;
             }
-            if(trommelDropMap.containsKey(item) && item != null) {
-                System.out.println("        " + item.getKey() + " yield: " + trommelDropMap.get(item)  + " (" + MathHelper.floor_float((float)(trommelDropMap.get(item))/64F) + " stacks) - " + String.format("%.2f", percentage) + "%");
+            if(amount != null) {
+                System.out.println("        " + item.namespaceID + " yield: " + amount  + String.format(" (%.2f stacks) - ", (float)(amount)/64F) + String.format("%.2f", percentage) + "%");
             }
         }
+        if (trommelDropMap.get("NULL") != null) {
+            float percentage = trommelDropMap.get("NULL") / (float) (passes);
+            percentage *= 100;
+            System.out.println("        " + "NULL" + " yield: " + trommelDropMap.get("NULL")  + " (" + MathHelper.floor_float((float)(trommelDropMap.get("NULL"))/64F) + " stacks) - " + String.format("%.2f", percentage) + "%");
+        }
+    }
+
+    public static void main(String[] args) {
+        Blocks.init();
+        Items.init();
+
+        new Registries();
+
+        // Load vanilla recipes
+        DataLoader.loadRecipesFromFile("/recipes/blast_furnace.json");
+        DataLoader.loadRecipesFromFile("/recipes/furnace.json");
+        DataLoader.loadRecipesFromFile("/recipes/trommel.json");
+        DataLoader.loadRecipesFromFile("/recipes/workbench.json");
+
+//        DataLoader.loadDataPacks(this);
+
+        TrommelBlockEntity trommel = new TrommelBlockEntity();
+        trommel.worldObj = new World();
+
+        trommel.simulateTrommelDrops(10000, Blocks.DIRT.getDefaultStack());
+        trommel.simulateTrommelDrops(10000, Blocks.GRAVEL.getDefaultStack());
+        trommel.simulateTrommelDrops(10000, Blocks.SAND.getDefaultStack());
+        trommel.simulateTrommelDrops(10000, Blocks.SOULSAND.getDefaultStack());
+        trommel.simulateTrommelDrops(10000, Blocks.BLOCK_CLAY.getDefaultStack());
+        trommel.simulateTrommelDrops(10000, Blocks.DIRT_SCORCHED_RICH.getDefaultStack());
     }
 
+    private static final Logger LOGGER = LogUtils.getLogger();
     private ItemStack[] itemStacks;
 
     public int burnTime;
diff --git a/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java b/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
index 142107b20..05b2a0555 100644
--- a/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
@@ -304,7 +304,7 @@ public class BasePistonBlock extends Block
                     int y2 = y + PistonDirections.yOffset[direction % 6];
                     int z2 = z + PistonDirections.zOffset[direction % 6];
                     world.playSoundEffect(null, 2001, x2, y2, z2, world.getBlockId(x2, y2, z2));
-                    Block.blocksList[world.getBlockId(x2, y2, z2)].dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x2, y2, z2, world.getBlockMetadata(x2, y2, z2), null);
+                    Block.blocksList[world.getBlockId(x2, y2, z2)].dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x2, y2, z2, world.getBlockMetadata(x2, y2, z2), null, null);
                     world.setBlockWithNotify(x2, y2, z2, 0);
                     break;
                 }
@@ -353,7 +353,7 @@ public class BasePistonBlock extends Block
             }
             if(Block.blocksList[j2].getPistonPushReaction() == 1)
             {
-                Block.blocksList[j2].dropBlockWithCause(world, EnumDropCause.WORLD, i1, j1, k1, world.getBlockMetadata(i1, j1, k1), null);
+                Block.blocksList[j2].dropBlockWithCause(world, EnumDropCause.WORLD, i1, j1, k1, world.getBlockMetadata(i1, j1, k1), null, null);
                 world.setBlockWithNotify(i1, j1, k1, 0);
                 break;
             }
diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
index a85ad3f76..ab847f4e2 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
@@ -95,7 +95,7 @@ public class MovingPistonBlock extends EntityBlock
     }
 
     @Override
-    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, BlockEntity blockEntity)
+    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, BlockEntity blockEntity, Player player)
     {
         if(world.isClientSide)
         {
@@ -104,7 +104,7 @@ public class MovingPistonBlock extends EntityBlock
         MovingPistonBlockEntity piston = getBlockEntity(world, x, y, z);
         if(piston != null)
         {
-            Block.blocksList[piston.getMovedId()].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null);
+            Block.blocksList[piston.getMovedId()].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java b/src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java
index 05064fd5b..027e1d67d 100644
--- a/src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java
@@ -41,7 +41,7 @@ public class PistonHeadBlock extends Block
             int i1 = world.getBlockMetadata(x, y, z);
             if(BasePistonBlock.isPowered(i1))
             {
-                Block.blocksList[k1].dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x, y, z, i1, null);
+                Block.blocksList[k1].dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x, y, z, i1, null, null);
                 world.setBlockWithNotify(x, y, z, 0);
             }
         }
